/*
	This file contains the interface for the TParser class.
	TParser is designed for use with PCYACC and Visual C++.
*/

#include "fstream.h"

const int YYMAXDEPTH = 200;				//	depth of parser stack

class TParser
	{
private:
	YYSTYPE     yyv[YYMAXDEPTH];		//	token stack
	int         yytoken,            	//  input token
				errct,              	//  error count
				errfl;              	//  error flag
	enum MESS
		{		FATAL,             		//	fatal error message
				START,					//	start syntax error
				EXPECT,					//  continue syntax error
				SENDIT                  //	conclude syntax error
		};
public:
	TParser( const char * filename );			//	constructor
	ifstream	*input;					//	input file stream
	char		nextchar;				//	lookahead char
	int         yylex( void );			//	lexical analyzer
	void        yymessage( MESS, int );	//	error messages
	int         yyparse( void );		//	syntax parser
	const char *yystring( int );		//	convert token to string
	};

const int YYFLAG     = -1000;  //  This symbol is required by PCYACC.


//	The following macros are supplied for compatibility with Unix yacc:

#define	yyerrok		errfl = 0
#define yyclearin	yytoken = -1
#define YYACCEPT	return(0)
#define YYABORT     return(1)
