
# line 7 "calc_jav.y"

/*#define YYSTYPE double    /* data type of yacc stack */

#define STAND_ALONE	1    
#define QUIT    ((double)101010)
#define LF 0x0a /* line feed character */
#define CR 0xd  /* carriage return */


# line 16 "calc_jav.y"
typedef union {
double db;
} YYSTYPE;
#define NEWLINE 257
#define NUMBER 258
#define UNARYMINUS 259
YYSTYPE yylval, yyval;
#define YYERRCODE 256

# line 54 "calc_jav.y"


public static void main(String args[])
{
  if (args.length>0)
    System.out.println("nonmeaningful arguments");

  System.out.println("*************************************************");
  System.out.println("*  SACALC: A Simple Arithmetic Calculator       *");
  System.out.println("*                                               *");
  System.out.println("*  1) at the prompt READY>                      *");
  System.out.println("*     you type in an expression, e.g. 1+2<CR>   *");
  System.out.println("*     SACALC will evaluate the expression       *");
  System.out.println("*     and the result is displayed               *");
  System.out.println("*  2) to terminate the program                  *");
  System.out.println("*     type QUIT                                 *");
  System.out.println("*  3) if you make a mistake                     *");
  System.out.println("*     SACALC will complain and start over again *");
  System.out.println("*                                               *");
  System.out.println("*************************************************");
  
  yyparse();

  System.out.println("*************************************************");
  System.out.println("*  SACALC: A Simple Arithmetic Calculator       *");
  System.out.println("*                                               *");
  System.out.println("*  normal termination -- bye!                   *");
  System.out.println("*************************************************");
}

private static PushbackInputStream in = 
  new PushbackInputStream(System.in);

private static int yylex()
{
  int c = 0;
  double intpart = 0;
  double decpart = 0;
  int deccnt = 0;

  try
  {
    c = in.read();      // the try and catch pair can be put on whole 
  }                     // function body to reduce the number of the pairs.
  catch (IOException e)
  {
    System.out.println(e);
	System.exit(-1);
  }

  while (c == ' ' || c == '\t' )
  {
    try
	{
	  c = in.read();
	}
	catch (IOException e)
	{
	  System.out.println(e);
	  System.exit(-1);
	}
  } 

  if (c == -1)
    return 0;

  if (c == '.' || c <= '9' && c >= '0')
  {
    if (c == '.')
	{
	  try
	  {
	    c = in.read();
	  }
	  catch (IOException e)
	  {
	    System.out.println(e);
		System.exit(-1);
	  }

	  if (c > '9' || c < '0')
	  {
	    try
		{
		  in.unread(c);
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}
		return '?';
	  }

      while (c <='9' && c >= '0')
	  {
	    decpart = decpart * 10 + c -'0';
		deccnt++;
		try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}
	  }

	  try
	  {
	    in.unread(c);
	  }
	  catch (IOException e)
	  {
	    System.out.println(e);
		System.exit(-1);
	  }

	  for (int k=0; k<deccnt; k++)
	  {
	    decpart = decpart/10;
	  }

	  yylval.db = decpart;
	}
	else
	{
	  while (c<='9' && c>='0')
	  {
	    intpart = intpart * 10 + c - '0';
		try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
	  System.exit(-1);
		}
	  }

	  if (c == '.')
	  {
	    deccnt = 0;
		try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}

		if (c>'9' || c<'0')
		{
		  yylval.db = intpart;
		  try
		  {
		    in.unread(c);
		  }
		  catch(IOException e)
		  {
		    System.out.println(e);
			System.exit(-1);
		  }
		}
		else
		{
		  while (c>='0' && c<='9')
		  {
		    decpart = decpart * 10 + c - '0';
			deccnt++;
			try
			{
			  c = in.read();
			}
			catch (IOException e)
			{
			  System.out.println(e);
			  System.exit(-1);
			}
		  }

		  try
		  {
		    in.unread(c);
		  }
		  catch (IOException e)
		  {
		    System.out.println(e);
			System.exit(-1);
		  }

		  for (int k=0; k<deccnt; k++)
		  {
		    decpart = decpart/10;
		  }

		  yylval.db = intpart + decpart;
		}
	  }
	  else
	  {
	    try
		{
		  in.unread(c);
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}

		yylval.db = intpart;
	  }
	}
	return NUMBER;
  }

  if ( c==LF || c==CR )
  {
    if ( c == CR ) c = LF;
    pcyylineno++;
    return( NEWLINE );
  }
   
  if (c=='Q' || c == 'q')
  {
    try
	{
	  c = in.read();
	}
	catch (IOException e)
	{
	  System.out.println(e);
	  System.exit(-1);
	}

	if (c=='U' || c == 'u')
	{
	  try
	  {
	    c = in.read();
	  }
	  catch (IOException e)
	  {
	    System.out.println(e);
		System.exit(-1);
	  }

	  if (c=='I' || c=='i')
	  {
	    try
		{
		  c = in.read();
		}
		catch (IOException e)
		{
		  System.out.println(e);
		  System.exit(-1);
		}

		if (c=='T' || c== 't')
		{
		  yylval.db = QUIT;
		  return -1;
		}
		else
		{
		  return '?';
		}
		
	  }
	  else
	  {
	    return '?';
	  }
	}
	else
	{
	  return '?';
	}
  }

  return c;
}


private static void prompt()
{
  System.out.print("READY> ");
  System.out.flush();
}

private static void yyerror(String s, String t)
{
	System.out.println(s+" near line " + pcyylineno);
}

private static String yydisplay(int ch)
{
	int i=0, tok_index = 0;
	int tok_num = 2;
	String[] tok = new String[tok_num]; 

	tok[tok_index++] = "NEWLINE";
	tok[tok_index++] = "NUMBER";

    switch (ch)
    {
        case             0:   return ("[end of file]");
		case          '\b':   return (    "'\\b'"    );
		case          '\f':   return (    "'\\f'"    );
		case          '\n':   return (    "'\\n'"    );
		case          '\r':   return (    "'\\r'"    );
		case          '\t':   return (    "'\\t'"    );
		case     YYERRCODE:   return (   "[error]"   );
    }

    if(ch > YYERRCODE && ch <= YYERRCODE + tok_num)
    {
        return (tok[ch - (YYERRCODE + 1)]);                  /* is %token */
    }
    return "char \""+(char)ch+"\"";
}
const int yyexca[] = {
  -1, 1,
  0, -1,
  -2, 0,
  0,
};

#define YYNPROD 12
#define YYLAST 227

const int yyact[] = {
       7,      13,       1,       0,       0,       6,      11,       9,
       7,      10,       0,      12,      11,       6,      20,      11,
       9,      12,      10,       3,      12,       0,       0,       0,
       0,       0,      14,      15,       0,      16,      17,      18,
      19,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       0,       0,       0,       0,       0,       0,       0,       0,
       4,       2,       5,       0,       0,       8,       0,       0,
       0,       0,       5,
};

const int yypact[] = {
   -4096,     -40,   -4096,     -36,    -256,   -4096,     -32,     -32,
   -4096,     -32,     -32,     -32,     -32,   -4096,   -4096,     -27,
     -30,     -30,   -4096,   -4096,   -4096,
};

const int yypgo[] = {
       0,       2,      19,
};

const int yyr1[] = {
       0,       1,       1,       1,       1,       2,       2,       2,
       2,       2,       2,       2,
};

const int yyr2[] = {
       0,       0,       2,       3,       3,       1,       2,       3,
       3,       3,       3,       3,
};

const int yychk[] = {
   -4096,      -1,     257,      -2,     256,     258,      45,      40,
     257,      43,      45,      42,      47,     257,      -2,      -2,
      -2,      -2,      -2,      -2,      41,
};

const int yydef[] = {
       1,      -2,       2,       0,       0,       5,       0,       0,
       3,       0,       0,       0,       0,       4,       6,       0,
       7,       8,       9,      10,      11,
};

/*****************************************************************/
/* PCYACC LALR parser driver routine -- a table driven procedure */
/* for recognizing sentences of a language defined by the        */
/* grammar that PCYACC analyzes. An LALR parsing table is then   */
/* constructed for the grammar and the skeletal parser uses the  */
/* table when performing syntactical analysis on input source    */
/* programs. The actions associated with grammar rules are       */
/* inserted into a switch statement for execution.               */
/*****************************************************************/


#ifndef YYMAXDEPTH
#define YYMAXDEPTH 200
#endif
#ifndef YYREDMAX
#define YYREDMAX 1000
#endif
#define PCYYFLAG -4096
#define WAS0ERR 0
#define WAS1ERR 1
#define WAS2ERR 2
#define WAS3ERR 3
#define yyclearin pcyytoken = -1
#define yyerrok   pcyyerrfl = 0
YYSTYPE yyv[YYMAXDEPTH];     /* value stack */
int pcyyerrct = 0;           /* error count */
int pcyyerrfl = 0;           /* error flag */
int redseq[YYREDMAX];
int redcnt = 0;
int pcyytoken = -1;          /* input token */


yyparse()
{
#ifdef YYSHORT
  const short *yyxi;
#else
  const int *yyxi;
#endif
#ifdef YYASTFLAG
    int ti; int tj;
#endif

#ifdef YYDEBUG
int tmptoken;
#endif
  int statestack[YYMAXDEPTH]; /* state stack */
  int      j, m;              /* working index */
  YYSTYPE *yypvt;
  int      tmpstate, *yyps, n;
  YYSTYPE *yypv;


  tmpstate = 0;
  pcyytoken = -1;


#ifdef YYDEBUG
  tmptoken = -1;
#endif


  pcyyerrct = 0;
  pcyyerrfl = 0;
  yyps = &statestack[-1];
  yypv = &yyv[-1];


  enstack:    /* push stack */
#ifdef YYDEBUG
    printf("at state %d, next token %d\n", tmpstate, tmptoken);
#endif
    if (++yyps - &statestack[YYMAXDEPTH-1] > 0) {
      yyerror("pcyacc internal stack overflow");
      return(1);
    }
    *yyps = tmpstate;
    ++yypv;
    *yypv = yyval;


  newstate:
    n = yypact[tmpstate];
    if (n <= PCYYFLAG) goto defaultact; /*  a simple state */


    if (pcyytoken < 0) if ((pcyytoken=yylex()) < 0) pcyytoken = 0;
    if ((n += pcyytoken) < 0 || n >= YYLAST) goto defaultact;


    if (yychk[n=yyact[n]] == pcyytoken) { /* a shift */
#ifdef YYDEBUG
      tmptoken  = pcyytoken;
#endif
      pcyytoken = -1;
      yyval = yylval;
      tmpstate = n;
      if (pcyyerrfl > 0) --pcyyerrfl;
      goto enstack;
    }


  defaultact:


    if ((n=yydef[tmpstate]) == -2) {
      if (pcyytoken < 0) if ((pcyytoken=yylex())<0) pcyytoken = 0;
      for (yyxi=yyexca; (*yyxi!= (-1)) || (yyxi[1]!=tmpstate); yyxi += 2);
      while (*(yyxi+=2) >= 0) if (*yyxi == pcyytoken) break;
      if ((n=yyxi[1]) < 0) { /* an accept action */
#ifdef YYASTFLAG
          yytfilep = fopen(yytfilen, "w");
          if (yytfilep == NULL) {
            fprintf(stderr, "Can't open t file: %s\n", yytfilen);
            return(0);          }
          for (ti=redcnt-1; ti>=0; ti--) {
            tj = svdprd[redseq[ti]];
            while (strcmp(svdnams[tj], "$EOP"))
              fprintf(yytfilep, "%s ", svdnams[tj++]);
            fprintf(yytfilep, "\n");
          }
          fclose(yytfilep);
#endif

        return (0);
      }
    }


    if (n == 0) {        /* error situation */
      switch (pcyyerrfl) {
        case WAS0ERR:          /* an error just occurred */
          yyerror("syntax error");
            ++pcyyerrct;
        case WAS1ERR:
        case WAS2ERR:           /* try again */
          pcyyerrfl = 3;
	   /* find a state for a legal shift action */
          while (yyps >= statestack) {
	     n = yypact[*yyps] + YYERRCODE;
	     if (n >= 0 && n < YYLAST && yychk[yyact[n]] == YYERRCODE) {
	       tmpstate = yyact[n];  /* simulate a shift of "error" */
	       goto enstack;
            }
	     n = yypact[*yyps];


	     /* the current yyps has no shift on "error", pop stack */
#ifdef YYDEBUG
            printf("error: pop state %d, recover state %d\n", *yyps, yyps[-1]);
#endif
	     --yyps;
	     --yypv;
	   }


	   yyabort:

#ifdef YYASTFLAG
              yytfilep = fopen(yytfilen, "w");
              if (yytfilep == NULL) {
                fprintf(stderr, "Can't open t file: %s\n", yytfilen);
                return(1);              }
              for (ti=1; ti<redcnt; ti++) {
                tj = svdprd[redseq[ti]];
                while (strcmp(svdnams[tj], "$EOP"))
                  fprintf(yytfilep, "%s ", svdnams[tj++]);
                fprintf(yytfilep, "\n");
              }
              fclose(yytfilep);
#endif

	     return(1);


	 case WAS3ERR:  /* clobber input char */
#ifdef YYDEBUG
          printf("error: discard token %d\n", pcyytoken);
#endif
          if (pcyytoken == 0) goto yyabort; /* quit */
	   pcyytoken = -1;
	   goto newstate;      } /* switch */
    } /* if */


    /* reduction, given a production n */
#ifdef YYDEBUG
    printf("reduce with rule %d\n", n);
#endif
#ifdef YYASTFLAG
    if ( redcnt<YYREDMAX ) redseq[redcnt++] = n;
#endif
    yyps -= yyr2[n];
    yypvt = yypv;
    yypv -= yyr2[n];
    yyval = yypv[1];
    m = n;
    /* find next state from goto table */
    n = yyr1[n];
    j = yypgo[n] + *yyps + 1;
    if (j>=YYLAST || yychk[ tmpstate = yyact[j] ] != -n) tmpstate = yyact[yypgo[n]];
    switch (m) { /* actions associated with grammar rules */
      
      case 1:
# line 29 "calc_jav.y"
      { prompt(); } break;
      case 2:
# line 31 "calc_jav.y"
      { prompt(); } break;
      case 3:
# line 33 "calc_jav.y"
      { if ( yypvt[-1].db == QUIT) {
      	      return(0);
      	   } else {
      	     System.out.println("  RESULT ====>" + yypvt[-1].db);
      	     System.out.flush();
      	     prompt();
      	   }
      	 } break;
      case 4:
# line 42 "calc_jav.y"
      { yyerrok;
      	     prompt();
      	   } break;
      case 5:
# line 46 "calc_jav.y"
      { yyval.db = yypvt[-0].db; } break;
      case 6:
# line 47 "calc_jav.y"
      { yyval.db = -yypvt[-0].db; } break;
      case 7:
# line 48 "calc_jav.y"
      { yyval.db = yypvt[-2].db + yypvt[-0].db; } break;
      case 8:
# line 49 "calc_jav.y"
      { yyval.db = yypvt[-2].db - yypvt[-0].db; } break;
      case 9:
# line 50 "calc_jav.y"
      { yyval.db = yypvt[-2].db * yypvt[-0].db; } break;
      case 10:
# line 51 "calc_jav.y"
      { yyval.db = yypvt[-2].db / yypvt[-0].db; } break;
      case 11:
# line 52 "calc_jav.y"
      { yyval.db = yypvt[-1].db; } break;    }
    goto enstack;
}
