class pcl_sk
{
	/* These data tables are stripped from C lexer generated by PCLEX */
	$T

	/* class member and constructor */
	private static FileInputStream lex_fis;

	public pcl_sk(FileInputStream finput)
	{
		lex_fis = finput;
	}
  
	/* These constants are in the form of macros in JAVA lexer skeleton */
	private static final int YY_END_TOK = 0;
	private static final int YY_NEW_FILE = -1;
	private static final int YY_DO_DEFAULT = -2;
	private static final int BUFSIZ = 4096;
	private static final int F_BUFSIZ = 4096;
	private static final int YY_BUF_SIZE = 8192;
	private static final int YY_BUF_MAX = 8191;
	private static final int YY_MAX_LINE = 4096;
	private static final int YY_BUF_LIM = 4095;
	private static final int YY_NULL = 0;

	/* These fields are declared in skeleton file for JAVA */
	private static int yy_start;
	private static int yy_b_buf_p;
	private static int yy_c_buf_p;
	private static int yy_e_buf_p;
	private static int yy_saw_eof = 1;
	private static int yy_init = 1;
	private static char yy_ch_buf[] = new char[YY_BUF_SIZE+1];
	private static int yy_st_buf[] = new int[YY_BUF_SIZE];
	private static char yy_hold_char;
	private static char yytext[] = new char[BUFSIZ];
	private static int yyleng;
	private static int yy_lp;	   /* moved from yylex local variable */
	private static int yy_curst; /* moved fron yylex local variable */
	private static int reject_flag = 0;

	private int yylineno = 1;

	int get_yylineno()
	{
		return yylineno;
	}

	int input()
	{
		int c;
		int yy_n_chars;
		int i, index = 0;

		YY_DO_BEFORE_SCAN();

		if (yy_c_buf_p == yy_e_buf_p)
		{
			if (yy_saw_eof!=0)
			{
				if (yywrap())
					return (-1);

				YY_INIT();
			}	  

			yy_b_buf_p = 0;
			yy_n_chars = YY_INPUT(yy_ch_buf, 0, YY_MAX_LINE);

			if (yy_n_chars == YY_NULL)
			{
				yy_saw_eof = 1;

				if (yywrap())
					return (-1);

				YY_INIT();

				return (input());	
			} /* end of if (yy_n_chars == YY_NULL) */

			yy_c_buf_p = -1;
			yy_e_buf_p = yy_n_chars -1;
		} 	/* end of if (yy_c_buf_p == yy_e_buf_p)   */

		c = yy_ch_buf[++yy_c_buf_p];

		YY_DO_BEFORE_ACTION();

		return (c);
	}

	void unput(char c)
	{
		int i;
		int yy_buf_pos = YY_BUF_MAX;

		YY_DO_BEFORE_SCAN();

		if (yy_c_buf_p == 0)
		{
			for (i=yy_e_buf_p; i>=yy_c_buf_p; --i)
			{
				yy_ch_buf[yy_buf_pos] = yy_ch_buf[i];
				yy_st_buf[yy_buf_pos] = yy_st_buf[i];
				--yy_buf_pos;
			} /* end of for (i=yy_e_buf_p; i>=yy_c_buf_p; --i) */	  

			yy_c_buf_p = YY_BUF_MAX - yy_e_buf_p;
			yy_e_buf_p = YY_BUF_MAX;
		} /* end of if (yy_c_buf_p == 0) */

		if (yy_c_buf_p<=0)
			YY_FATAL_ERROR("L0027: PCLEX scanner push-back overflow");

		if (yy_c_buf_p>=yy_b_buf_p && yy_ch_buf[yy_c_buf_p] == '\n')
			yy_ch_buf[yy_c_buf_p -1 ] = '\n';

		yy_ch_buf[yy_c_buf_p--] = c;

		YY_DO_BEFORE_ACTION();
	}

	private static void YY_DEFAULT_ACTION()
	{
		int i;

lp1:	for (i=0; i<BUFSIZ; i++)
		{
			if (yytext[i]!='\0')
				System.out.print(yytext[i]);
			else
				break lp1;
		}
	}

	private static int YY_INPUT(char buf[], int buf_offset, int max_size)
	{
		int index = 0;
		int c;

get_input0:	
		while (index<max_size)
		{
			try 
			{
				c = lex_fis.read();
				if( c != 0x0d )
				{
					buf[buf_offset+index] =(char)c;
					if (c==-1)
						break get_input0;
					index++;
				}
			}    
			catch (IOException e)
			{
				YY_FATAL_ERROR("L0048: fread() in PCLEX scanner failed");
				System.exit(-1);
			}	            
		}
		return index;
	}

	private static void YY_OUTPUT(char c)
	{
		System.out.print(c);
	}

	private static void YY_FATAL_ERROR(String s)
	{
		System.err.println(s+"\n");
		System.err.flush();
		System.exit(-1);
	}

	private static boolean yywrap()
	{
		return true;
	}

	private static void YY_SET_BOL(char array[], int pos)
	{
		array[pos-1] = '\n';
	}

	private static void yyless(int n)
	{
		YY_DO_BEFORE_SCAN();
		yy_c_buf_p = yy_b_buf_p + (n) - 1;
		YY_DO_BEFORE_ACTION();
	}

	private static void YY_INIT()
	{
		yyleng = 0;
		yy_c_buf_p = 0;
		yy_e_buf_p = 0;

		yy_hold_char = '\n';
		yy_ch_buf[yy_c_buf_p] = '\n';

		yytext[0] = yy_ch_buf[0];

		yy_saw_eof = 0;
	}

	private static int YY_LENG()
	{
		return (yy_c_buf_p - yy_b_buf_p + 1);
	}

	private static void YY_DO_BEFORE_SCAN()
	{
		yytext[yyleng] = yy_hold_char;
	}

	private static void YY_DO_BEFORE_ACTION()
	{
		int i;
		  
		for( i = yy_b_buf_p; i <= yy_c_buf_p; i++ )
			yytext[i-yy_b_buf_p] = yy_ch_buf[i];
	
		yyleng  = YY_LENG();
		yy_hold_char = yytext[yyleng];
		yytext[yyleng] = '\0';
	}

	private static void REJECT(int yy_full_match)
	{
		YY_DO_BEFORE_SCAN();
		yy_c_buf_p = yy_full_match;
		++yy_lp;
		/* goto find_rule; */
		reject_flag = 1;
	}

	int yylex()
	{
		char yy_sym;
		int yy_n_chars, yy_iii, yy_buf_pos, yy_act = 0, yy_full_match;
		int get_next_token_flag = 0; /* used to get entry point */
		int index = 0;
		int ch;

		int i=0;

		if (yy_init!=0)
		{
			YY_INIT();

			yy_start = 1;
			yy_init = 0;  
		}

		get_next_token_flag = 1;

do_action:
		while (true)
		{
			if (get_next_token_flag!=1)
				yy_full_match = yy_c_buf_p;

			for ( ; ; )
			{
				if (get_next_token_flag!=1)
				{
					YY_DO_BEFORE_ACTION();

					switch (yy_act)
					{
						$A
						case YY_NEW_FILE:
							break;
						case YY_END_TOK:
							return YY_END_TOK;
						default:
							YY_FATAL_ERROR("L0028: fatal PCLEX scanner internal error");
					} /* end of switch (yy_act) */
				} /* end of if (get_next_token_flag!=1)*/

			if (reject_flag != 1)
			{
				get_next_token_flag = 0;
				YY_DO_BEFORE_SCAN(); 

				yy_curst = yy_start;

				if (yy_ch_buf[yy_c_buf_p] == '\n')
					yy_curst = yy_curst + 1;

				yy_b_buf_p = yy_c_buf_p + 1 ;
		
do_while:
				do {
						if (yy_c_buf_p == yy_e_buf_p)
						{
							if (yy_e_buf_p >= YY_BUF_LIM)
							{
								yy_n_chars = yy_e_buf_p - yy_b_buf_p;

								if (yy_n_chars >= 0)
								{
									for (yy_iii=0; yy_iii<=yy_n_chars;++yy_iii )
									{
										yy_buf_pos = yy_b_buf_p + yy_iii;
										yy_ch_buf[yy_iii] = yy_ch_buf[yy_buf_pos];
										yy_st_buf[yy_iii] = yy_st_buf[yy_buf_pos];
									}
								} /* end of if (yy_n_chars >= 0) */

								yy_b_buf_p = 0;
								yy_e_buf_p = yy_n_chars;

								if (yy_e_buf_p >= YY_BUF_LIM)
									YY_FATAL_ERROR("L0029: PCLEX input buffer overflowed");

								yy_c_buf_p = yy_e_buf_p;
							}
							else if (yy_saw_eof!=0)
							{ 
								/* saweof: */
								if (yy_b_buf_p <= yy_e_buf_p)
									break do_while;
								if (yywrap())
									yy_act = YY_END_TOK;
								else
								{
									YY_INIT();

									yy_act = YY_NEW_FILE;
								}
								continue do_action;
							} /* end of if (yy_e_buf_p >= YY_BUF_LIM) */

							yy_n_chars = YY_INPUT(yy_ch_buf, yy_c_buf_p+1, YY_MAX_LINE);

							index = 0;
							if (yy_n_chars<0)
								YY_FATAL_ERROR("L0048: fread() in PCLEX scanner failed");

							if (yy_n_chars == YY_NULL)
							{
								if (yy_saw_eof!=0)
									YY_FATAL_ERROR("L0030: PCLEX scanner saw EOF twice - shouldn't happen");
								yy_saw_eof = 1;
          
								/* saweof: */
								if (yy_b_buf_p <= yy_e_buf_p)
								{
									break do_while;
								}
								if (yywrap())
								{
									yy_act = YY_END_TOK;
								}
								else
								{
									YY_INIT();

									yy_act = YY_NEW_FILE;
								}
								continue do_action;
							} /* end of if (yy_n_chars == YY_NULL) */

							yy_e_buf_p = yy_e_buf_p + yy_n_chars;
						} /* end of if (yy_c_buf_p == yy_e_buf_p) */

						yy_c_buf_p = yy_c_buf_p + 1; 
						yy_sym = yy_ch_buf[yy_c_buf_p];
						if (yy_sym == '\000')
							yy_sym = '\001';

						while (c[(short)b[yy_curst] + (int)yy_sym] != yy_curst)
						{
							yy_curst = d[yy_curst];
						}

						yy_curst = n[(short)b[yy_curst] + (int)yy_sym];
						yy_st_buf[yy_c_buf_p] = yy_curst;
					} while (b[yy_curst] != YY_JAM_BASE); /* end of do-while */
				} /* end of if (reject_flag!=1) */

				if ((yy_c_buf_p >= yy_b_buf_p) || (reject_flag == 1))
				{
					if (reject_flag!=1)
					{
						yy_curst = yy_st_buf[yy_c_buf_p];
						yy_lp = l[yy_curst];
					}

          /* find_rule: */
find_rule:		  
					for ( ; ; )
					{
						reject_flag = 0;  /* reset REJECT flag */
						if ((yy_lp!=0) && (yy_lp <l[yy_curst +1]))
						{
							yy_act = a[yy_lp];
							continue do_action;
						}

						yy_c_buf_p = yy_c_buf_p -1;
						if (yy_c_buf_p < yy_b_buf_p)
							break find_rule;

						yy_curst = yy_st_buf[yy_c_buf_p];
						yy_lp = l[yy_curst];

					} /* end of for ( ; ; ) */
				} /* end of if (yy_c_buf_p >= yy_b_buf_p */

				yy_c_buf_p = yy_c_buf_p + 1;
				yy_act = YY_DO_DEFAULT;
			} /* end of for ( ; ; ): looping for ever */
		} /* end of while( true ): pseudo loop to remove goto statement */
	} /* end of yylex() */ 

	char [] get_yytext()
	{
		int i=0, elem_size;

		/* get actaul yytext element size */
		while (yytext[i]!='\0')
			i++;
		elem_size = i;

		char text[] = new char[elem_size+1];
		for (i=0; i<=elem_size; i++)
			text[i] = yytext[i];

		return text;
	}
}
